//******************************************************************************
//
// Copyright (c) 2015 Microsoft Corporation. All rights reserved.
//
// This code is licensed under the MIT License (MIT).
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//******************************************************************************

#import <Foundation/NSObject.h>

@class NSManagedObjectID,NSMutableDictionary;

@interface NSAtomicStoreCacheNode : NSObject {
   NSManagedObjectID   *_objectID;
   NSMutableDictionary *_propertyCache;
}

-initWithObjectID:(NSManagedObjectID *)objectID;

-(NSManagedObjectID *)objectID;

-(NSMutableDictionary *)propertyCache;

-(void)setPropertyCache:(NSMutableDictionary *)value;

-(void)setValue:value forKey:(NSString *)key;

-valueForKey:(NSString *)key;

@end
