/* Copyright (c) 2006-2007 Christopher J. W. Lloyd

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */

#ifndef _NSRANGE_H_
#define _NSRANGE_H_

#import <Foundation/NSObject.h>

typedef struct _NSRange {
    NSUInteger location;
    NSUInteger length;
} NSRange;

typedef NSRange *NSRangePointer;

FOUNDATION_EXPORT NSRange NSMakeRange(NSUInteger loc, NSUInteger len);
FOUNDATION_EXPORT NSUInteger NSMaxRange(NSRange range);
FOUNDATION_EXPORT BOOL NSEqualRanges(NSRange range, NSRange otherRange);
FOUNDATION_EXPORT BOOL NSLocationInRange(NSUInteger location, NSRange range);

FOUNDATION_EXPORT NSString *NSStringFromRange(NSRange range);
FOUNDATION_EXPORT NSRange   NSRangeFromString(NSString *s);

FOUNDATION_EXPORT NSRange   NSIntersectionRange(NSRange range,NSRange otherRange);
FOUNDATION_EXPORT NSRange   NSUnionRange(NSRange range,NSRange otherRange);

#endif /* _NSRANGE_H_ */